<center><a href="ex3f.F">Actual source code: ex3f.F</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:21:03+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a>!
<a name="line2">  2: </a>!
<a name="line3">  3: </a>!  Description: Displays a vector visually.
<a name="line4">  4: </a>!
<a name="line5">  5: </a>!<font color="#B22222">/*T</font>
<a name="line6">  6: </a><font color="#B22222">!   Concepts: vectors^drawing vectors;</font>
<a name="line7">  7: </a><font color="#B22222">!   Processors: n</font>
<a name="line8">  8: </a><font color="#B22222">!T*/</font>
<a name="line9">  9: </a>! -----------------------------------------------------------------------

<a name="line11"> 11: </a>      program main
<a name="line12"> 12: </a>      implicit none

<a name="line14"> 14: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line15"> 15: </a>!                    Include files
<a name="line16"> 16: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line17"> 17: </a>!
<a name="line18"> 18: </a>!  The following include statements are required <font color="#4169E1">for</font> Fortran programs
<a name="line19"> 19: </a>!  that use PETSc vectors:
<a name="line20"> 20: </a>!     petsc.h       - base PETSc routines
<a name="line21"> 21: </a>!     petscvec.h    - vectors
<a name="line22"> 22: </a>!  Include petscviewer.h so that we can use the PETSc viewers.
<a name="line23"> 23: </a>!
<a name="line24"> 24: </a> #include <A href="../../../../../include/finclude/petsc.h.html">include/finclude/petsc.h</A>
<a name="line25"> 25: </a> #include <A href="../../../../../include/finclude/petscvec.h.html">include/finclude/petscvec.h</A>
<a name="line26"> 26: </a> #include <A href="../../../../../include/finclude/petscviewer.h.html">include/finclude/petscviewer.h</A>

<a name="line28"> 28: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line29"> 29: </a>!                 Beginning of program
<a name="line30"> 30: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line32"> 32: </a>      <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>     x
<a name="line33"> 33: </a>      <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>  viewer
<a name="line34"> 34: </a>      <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>  v
<a name="line35"> 35: </a>      <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> i,istart,iend,n,ione
<a name="line36"> 36: </a>      <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr
<a name="line37"> 37: </a>      <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> flg

<a name="line39"> 39: </a>      call <A href="../../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(PETSC_NULL_CHARACTER,ierr)
<a name="line40"> 40: </a>      n = 50
<a name="line41"> 41: </a>      call <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(PETSC_NULL_CHARACTER,'-n',n,flg,ierr)

<a name="line43"> 43: </a>!  Create a vector, specifying only its global dimension.
<a name="line44"> 44: </a>!  When using <A href="../../../../../docs/manualpages/Vec/VecCreate.html#VecCreate">VecCreate</A>(), <A href="../../../../../docs/manualpages/Vec/VecSetSizes.html#VecSetSizes">VecSetSizes</A>() and <A href="../../../../../docs/manualpages/Vec/VecSetFromOptions.html#VecSetFromOptions">VecSetFromOptions</A>(),
<a name="line45"> 45: </a>!  the vector format (currently parallel
<a name="line46"> 46: </a>!  or sequential) is determined at runtime.  Also, the parallel
<a name="line47"> 47: </a>!  partitioning of the vector is determined by PETSc at runtime.
<a name="line48"> 48: </a>      call <A href="../../../../../docs/manualpages/Vec/VecCreate.html#VecCreate">VecCreate</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,x,ierr)
<a name="line49"> 49: </a>      call <A href="../../../../../docs/manualpages/Vec/VecSetSizes.html#VecSetSizes">VecSetSizes</A>(x,<A href="../../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,n,ierr)
<a name="line50"> 50: </a>      call <A href="../../../../../docs/manualpages/Vec/VecSetFromOptions.html#VecSetFromOptions">VecSetFromOptions</A>(x,ierr)

<a name="line52"> 52: </a>!  Currently, all PETSc parallel vectors are partitioned by
<a name="line53"> 53: </a>!  contiguous chunks of rows across the processors.  Determine
<a name="line54"> 54: </a>!  which vector are locally owned.
<a name="line55"> 55: </a>      call <A href="../../../../../docs/manualpages/Vec/VecGetOwnershipRange.html#VecGetOwnershipRange">VecGetOwnershipRange</A>(x,istart,iend,ierr)

<a name="line57"> 57: </a>!  Set the vector elements.
<a name="line58"> 58: </a>!   - Always specify global locations of vector entries.
<a name="line59"> 59: </a>!   - Each processor needs to insert only elements that it owns locally.
<a name="line60"> 60: </a>      ione = 1
<a name="line61"> 61: </a>      <font color="#4169E1">do</font> 100 i=istart,iend-1
<a name="line62"> 62: </a>         v = dble(i)
<a name="line63"> 63: </a>         call <A href="../../../../../docs/manualpages/Vec/VecSetValues.html#VecSetValues">VecSetValues</A>(x,ione,i,v,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,ierr)
<a name="line64"> 64: </a> 100  <font color="#4169E1">continue</font>

<a name="line66"> 66: </a>!  Assemble vector, using the 2-step process:
<a name="line67"> 67: </a>!    <A href="../../../../../docs/manualpages/Vec/VecAssemblyBegin.html#VecAssemblyBegin">VecAssemblyBegin</A>(), <A href="../../../../../docs/manualpages/Vec/VecAssemblyEnd.html#VecAssemblyEnd">VecAssemblyEnd</A>()
<a name="line68"> 68: </a>!  Computations can be done <font color="#4169E1">while</font> messages are in transition
<a name="line69"> 69: </a>!  by placing code between these two statements.
<a name="line70"> 70: </a>      call <A href="../../../../../docs/manualpages/Vec/VecAssemblyBegin.html#VecAssemblyBegin">VecAssemblyBegin</A>(x,ierr)
<a name="line71"> 71: </a>      call <A href="../../../../../docs/manualpages/Vec/VecAssemblyEnd.html#VecAssemblyEnd">VecAssemblyEnd</A>(x,ierr)

<a name="line73"> 73: </a>!  Open an X-window viewer.  Note that we specify the same communicator
<a name="line74"> 74: </a>!  <font color="#4169E1">for</font> the viewer as we used <font color="#4169E1">for</font> the distributed vector (<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>).
<a name="line75"> 75: </a>!    - Helpful runtime option:
<a name="line76"> 76: </a>!         -draw_pause &lt;pause&gt; : sets time (in seconds) that the
<a name="line77"> 77: </a>!               program pauses after <A href="../../../../../docs/manualpages/Draw/PetscDrawPause.html#PetscDrawPause">PetscDrawPause</A>() has been called
<a name="line78"> 78: </a>!              (0 is <font color="#4169E1">default</font>, -1 implies until user input).

<a name="line80"> 80: </a>      call <A href="../../../../../docs/manualpages/Viewer/PetscViewerDrawOpen.html#PetscViewerDrawOpen">PetscViewerDrawOpen</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,PETSC_NULL_CHARACTER,        &amp;
<a name="line81"> 81: </a>     &amp;                   PETSC_NULL_CHARACTER,0,0,300,300,viewer,ierr)

<a name="line83"> 83: </a>!  View the vector
<a name="line84"> 84: </a>      call <A href="../../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(x,viewer,ierr)

<a name="line86"> 86: </a>!  Free work space.  All PETSc objects should be destroyed when they
<a name="line87"> 87: </a>!  are no longer needed.

<a name="line89"> 89: </a>      call <A href="../../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(viewer,ierr)
<a name="line90"> 90: </a>      call <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(x,ierr)

<a name="line92"> 92: </a>      call <A href="../../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>(ierr)
<a name="line93"> 93: </a>      end
<a name="line94"> 94: </a>
</pre>
</body>

</html>
